﻿* Encoding: UTF-8.
*Euclidean space tools
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_SPTOD*/***************************************************************************************.
define !KO_sptod(cols= !charend('/') /dist= !charend('/'))
set results none.
flip vari= !cols /newname= varname_.
set results list.
matrix.
get m /vari= !cols /names= names.
do if any(m<>t(m)).
-print /title '>WARNING. Входящая матрица не вполне симметрична по значениям.'.
-print /title ' Симметричность восстановлена усреднением симметрических эл-тов матрицы.' /space= 0.
-comp m= (m+t(m))/2.
end if.
print (eval(m)*ncol(m)/trace(m)) /title= 'Собственные числа входящей матрицы (перешкалированы к средней=1):'.
comp hsq= kroneker(diag(m),make(1,ncol(m),1)).
comp m= hsq+t(hsq)-2*m.
do if any(m<0).
-print /title '>WARNING. Конфигурация настолько неевклидова, что некоторые кв. расстояния <0.'.
 !if (!dist<>'SEUCLID') !then
- print /title ' Из них извлечен корень, как из полож-ных, и отриц. знак им сохранён.' /space= 0.
 !ifend
end if.
!if (!dist<>'SEUCLID') !then
-comp m= (-(m<0)+(m>=0))&*sqrt(abs(m)).
!ifend
comp m= {make(ncol(m),1,'PROX'),t(names),m}.
comp names= {'rowtype_','varname_',names}.
save m /outfile= * /names= names /string= rowtype_ varname_.
end matrix.
!if (!dist=!null) !then !let !dst= 'EUCLID' !else !let !dst= !dist !ifend
val lab rowtype_ 'PROX' !quote(!conc('DISSIMILARITY ',!dst)).
!enddefine.

*/*!KO_DTOSP*/***************************************************************************************.
define !KO_sptoeuc(cols= !charend('/') /k= !charend('/') /elong= !charend('/') /return= !charend('/') /mxiter= !charend('/') !default(500))
set mxloops !mxiter results none.
flip vari= !cols /newname= varname_.
set results list.
matrix.
get sp /vari= !cols /names= names.
do if any(sp<>t(sp)).
-print /title '>WARNING. Входящая матрица не вполне симметрична по значениям.'.
-print /title ' Симметричность восстановлена усреднением симметрических эл-тов матрицы.' /space= 0.
-comp sp= (sp+t(sp))/2.
end if.
comp oldtr= trace(sp).
comp eival= eval(sp).
print {eival,(eival*ncol(sp)/trace(sp))} /title= 'Исходные собственные числа (справа - перешкалированные к средней=1):' /format= f20.15.
do if eival(nrow(eival))>=0.
-print /title= 'Итераций не требуется: входящая SSCP матрица евклидова.'. 
-print /title= 'Она выведена в новое окно данных.'.
else.
 !if (!k=!null) !then
- comp k= csum(diag(sp))/ncol(sp)/100.
 !else
- comp k= !k.
 !ifend
-loop i= 1 to !mxiter.
  !if (!elong='H') !then
-  comp h= kroneker(sqrt(diag(sp)),make(1,ncol(sp),1)).
-  comp sp= !k*(h+t(h)+!k)+sp.
  !else
-  comp sp= !k+sp.
  !ifend
- comp eival= eval(sp).
-end loop if eival(nrow(eival))>=0.
-print i /title= 'Потребовалось итераций:'.
-print {eival,(eival*ncol(sp)/trace(sp))} /title= 'Достигнутые собственные числа (справа - перешкалированные к средней=1):' /format= f20.15.
-do if eival(nrow(eival))<0.
- print /title= '>WARNING. Евклидовость не достигнута. Попробуйте увеличить MXITER или K.'.
  !if (!elong='H') !then
-  print /title= ' Если не помогает, попробуйте ELONG=HSQ.' /space= 0.
  !else
-  print /title= ' Если не помогает, неевклидовы расстояния между точками, а не диагональ.' /space= 0.
  !ifend
-end if.
-print /title= 'Измененная SSCP матрица выведена в новое окно данных.'.
-!if (!return='YES') !then
- comp sp= sp*oldtr/trace(sp).
- print /title= 'Она пересчитана так, чтобы сумма диагональных эл-тов стала исходной.'.
- comp eival= eval(sp).
- print {eival,(eival*ncol(sp)/trace(sp))} /title= 'Ее собственные числа (справа - перешкалированные к средней=1):' /format= f20.15.
-!ifend
end if.
comp sp= {make(ncol(sp),1,'PROX'),t(names),sp}.
comp names= {'rowtype_','varname_',names}.
save sp /outfile= * /names= names /string= rowtype_ varname_.
end matrix.
val lab rowtype_ 'PROX' 'SIMILARITY SSCP'.
!enddefine.

*/*!KO_DTOEUC*/***************************************************************************************.
define !KO_dtoeuc(cols= !charend('/') /k= !charend('/') /mxiter= !charend('/') !default(500))
set mxloops !mxiter results none.
flip vari= !cols /newname= varname_.
set results list.
matrix.
get d /vari= !cols /names= names.
do if any(d<>t(d)).
-print /title '>WARNING. Входящая матрица не вполне симметрична по значениям.'.
-print /title ' Симметричность восстановлена усреднением симметрических эл-тов матрицы.' /space= 0.
-comp d= (d+t(d))/2.
end if.
comp rmean= kroneker(rsum(d&**2)/ncol(d),make(1,ncol(d),1)).
comp eival= eval((rmean+t(rmean)-d&**2-msum(d&**2)/ncol(d)**2)/2).
print {eival,eival*ncol(d)/csum(eival)} /title= 'Исходные собственные числа (справа - перешкалированные к средней=1):' /format= f20.15.
do if eival(nrow(eival))>=0.
-print /title= 'Итераций не требуется: входящая матрица расстояний евклидова.'. 
-print /title= 'Она выведена в новое окно данных.'.
else.
 !if (!k=!null) !then
- comp k= msum(d)/(ncol(d)**2-ncol(d))/100.
 !else
- comp k= !k.
 !ifend
-loop i= 1 to !mxiter.
- comp d= d+k.
- call setdiag(d,0).
- comp rmean= kroneker(rsum(d&**2)/ncol(d),make(1,ncol(d),1)).
- comp eival= eval((rmean+t(rmean)-d&**2-msum(d&**2)/ncol(d)**2)/2).
-end loop if eival(nrow(eival))>=0.
-print i /title= 'Потребовалось итераций:'.
-print {eival,eival*ncol(d)/csum(eival)} /title= 'Достигнутые собственные числа (справа - перешкалированные к средней=1):' /format= f20.15.
-do if eival(nrow(eival))<0.
- print /title= '>WARNING. Евклидовость не достигнута. Попробуйте увеличить MXITER или K.'.
-end if.
-print /title= 'Измененная матрица расстояний выведена в новое окно данных.'.
end if.
comp d= {make(ncol(d),1,'PROX'),t(names),d}.
comp names= {'rowtype_','varname_',names}.
save d /outfile= * /names= names /string= rowtype_ varname_.
end matrix.
val lab rowtype_ 'PROX' 'DISSIMILARITY EUCLID'.
!enddefine.
